Page MenuHomePhabricator

Adjust the legend on Recent Changes page
Closed, ResolvedPublic

Description

As part of the changes planned for Integrated Filters, we need to move the Legend of abbreviations. At the same time, we can clarify this feature a bit.

Changes to Legend box

  • Move the legend to the results area (floating to the right).
    • In order to make the best use of space when the legend is expanded, we can show it as a floating element next to the list of results (as opposed to pushing them down). Technically this can be achieved by moving the legend (".mw-changeslist-legend" element) into the list of changes (".mw-changeslist"). You can open the browser console and write the following to see how that would work: > $(".mw-changeslist-legend").prependTo(".mw-changeslist").css("max-width","250px")
  • The legend is open by default (as now).
  • Once collapsed (or subsequently opened) the Legend box retains the selected state (as now).
  • The box gets a new name. Please change from "Legend" to "List of abbreviations."
  • The Help link continues to link to https://en.wikipedia.org/wiki/Help:Watchlist#How_to_read_a_watchlist

Event Timeline

Restricted Application added a subscriber: Aklapper. · View Herald TranscriptJun 16 2017, 9:27 AM
Pginer-WMF updated the task description. (Show Details)Jun 16 2017, 10:28 AM
Pginer-WMF renamed this task from adjust the legend on recent changes page to Adjust the legend on Recent Changes page.Jun 16 2017, 10:40 AM
Pginer-WMF updated the task description. (Show Details)
Pginer-WMF updated the task description. (Show Details)
Pginer-WMF updated the task description. (Show Details)
Mooeypoo added a subscriber: Mooeypoo.EditedJun 27 2017, 12:41 AM

@Pginer-WMF question that will affect implementation: What happens if there are no results? Can we not show the legend in such a case?

If so, we can remove the legend in the backend as we request results, which will be a lot easier to accomplish than sending it separate and having the front end constantly remove/reattach it.

However, when the result list is empty, the frontend replaces the message with our own -- and that means that we won't have the legend shown. I could change that and show the legend anyways, but since there are no results as it is, is it even needed in that case?

@Pginer-WMF question that will affect implementation: What happens if there are no results? Can we not show the legend in such a case?

Not showing the legend when there are no results sounds good to me. The legend is not needed to clarify anything, and provides information you cannot use at that moment.

Change 361712 had a related patch set uploaded (by Mooeypoo; owner: Mooeypoo):
[mediawiki/core@master] Special:RecentChanges - Move legend into results

https://gerrit.wikimedia.org/r/361712

Change 361712 merged by jenkins-bot:
[mediawiki/core@master] RCFilters: Move legend into results (both js and nojs output)

https://gerrit.wikimedia.org/r/361712

Checked in betalabs:
Collapsed legend:


Expanded legend:

No legend displayed when there are no results:

QA Recommendation: Resolve

There's something about this that I've been uncomfortable with, and now that I see the implementation on beta the penny dropped as to what it is. Actually, there are a couple of things;

Making the legend collapsed by default: Did this, in fact, happen? If so, I don't understand the thinking behind it. It is impossible for new users to intuit the meaning of the various symbols in the legend. So if users get this page with the legend collapsed, we are making it that much harder for them to ever learn the meaning. Don't we want them to learn, and have a better understanding of the results? I suggest the box be open by default.

Using the word "Legend" by itself: In its collapsed state, the simple word "Legend" is not very explanatory as to what this is. Obviously, this problem is more severe if we make the box closed by default. But even without that, I think we can improve this. Typically, one has a 'legend" of a map or chart of some kind. Thus, to begin with, this term is not a common thing on search results. And then there's the fact that in its collapsed state it's quite small and insignificant looking. Given the width of the box here, we have some room to expatiate. So I suggest a more descriptive title. Here are some name suggestions. See if any of these work for you:

  • Legend of abbreviations
  • Abbreviations defined
  • Abbreviations used on this page

Making the legend collapsed by default: Did this, in fact, happen? If so, I don't understand the thinking behind it. It is impossible for new users to intuit the meaning of the various symbols in the legend. So if users get this page with the legend collapsed, we are making it that much harder for them to ever learn the meaning. Don't we want them to learn, and have a better understanding of the results? I suggest the box be open by default.

The thinking is that with the new filters, knowing the meaning of those characters is less needed. If a user wants to focus only or highlight new pages we provide a much clear path through the filters (the previous alternative is to visually scan through the "N"s). If the user wants to know what the "N" indicator is on a particular item, hovering over it provides an explanation. Improving this to show the tooltip earlier or making it appear on click can be more effective approach (since it is contectual) than making a separate legend more prominent.

If we think on new users, the legend provides them with several definitions that are not shown initially or are not very relevant for them such as bot (b), unpatrolled (!) or Wikidata (D). I'd be curious to know how much new users interiorize the meaning of those characters despite the legend being open.

I'm ok in keeping the legend open initially since there is a clear way to get the space back, but we should be aware that this comes also to the price of taking attention away from the main filter UI.

Using the word "Legend" by itself: In its collapsed state, the simple word "Legend" is not very explanatory as to what this is. Obviously, this problem is more severe if we make the box closed by default. But even without that, I think we can improve this. Typically, one has a 'legend" of a map or chart of some kind. Thus, to begin with, this term is not a common thing on search results. And then there's the fact that in its collapsed state it's quite small and insignificant looking. Given the width of the box here, we have some room to expatiate. So I suggest a more descriptive title. Here are some name suggestions. See if any of these work for you:

  • Legend of abbreviations
  • Abbreviations defined
  • Abbreviations used on this page

Makes sense. Along those lines I'd consider "List of abbreviations" as a simpler alternative.

@Mooeypoo, I see you claimed this task and that there is a Patch for Review. But it was still in Product Design, so changes were still being made to the spec.

It's now in RFP. Please review the rewritten description, above. In particular, note the change of title and the fact that the default state will be open, not closed.

@Mooeypoo, I see you claimed this task and that there is a Patch for Review. But it was still in Product Design, so changes were still being made to the spec.
It's now in RFP. Please review the rewritten description, above. In particular, note the change of title and the fact that the default state will be open, not closed.

It was, in fact, in untriaged, when I initially claimed and implemented it ;)

Mooeypoo moved this task from Untriaged to Needs Review on the Collaboration-Team-Triage (Collab-Team-Q4-Apr-Jun-2017) board.

In any case, I can make fixes, but there's a small issue with default state -- we are currently using a cookie to remember the state you are in. I can make the default state open, but that would be overridden by your current cookie, unless we want to create a brand new cookie.

But if we're creating a new cookie, do we override people's preference (so, if they already had it closed before, do we open it for them now?) that seems a tad disruptive...

In other words, I can make it so that by default, if you've never touched the 'expand/shrink' button, the box is expanded by default -- but anyone who's ever touched it before will not be affected.

In other words, I can make it so that by default, if you've never touched the 'expand/shrink' button, the box is expanded by default -- but anyone who's ever touched it before will not be affected.

Yes. Let's preserve people choice based on their previous behaviour. If a used actively closed/expanded the legend the last time, let's keep it closed/expanded the next time. The default state applies only to those not having interacted with the legend before to expand or collapse it.

There's something about this that I've been uncomfortable with, and now that I see the implementation on beta the penny dropped as to what it is. Actually, there are a couple of things;
Making the legend collapsed by default: Did this, in fact, happen? If so, I don't understand the thinking behind it. It is impossible for new users to intuit the meaning of the various symbols in the legend. So if users get this page with the legend collapsed, we are making it that much harder for them to ever learn the meaning. Don't we want them to learn, and have a better understanding of the results? I suggest the box be open by default.
Using the word "Legend" by itself: In its collapsed state, the simple word "Legend" is not very explanatory as to what this is. Obviously, this problem is more severe if we make the box closed by default. But even without that, I think we can improve this. Typically, one has a 'legend" of a map or chart of some kind. Thus, to begin with, this term is not a common thing on search results. And then there's the fact that in its collapsed state it's quite small and insignificant looking. Given the width of the box here, we have some room to expatiate. So I suggest a more descriptive title. Here are some name suggestions. See if any of these work for you:

  • Legend of abbreviations
  • Abbreviations defined
  • Abbreviations used on this page

One more question -

Right now, the moving of the legend (and any change in it) is only done if you have the beta feature enabled. I assume (verifying!) that this will be the same case for changing of the text? Otherwise, we produce a wider change that I'm slightly concerned will produce a lot of noise?

It will then become the default to everyone (js and no-js) when RCFilters go out of beta.

Is that right, or should I just change this for everyone right now? (I'm not sure if we need to do any sort of consultation or announcement to users if we change it to all indiscriminately?)

It's fine to do this all for the beta only. As you say, that will become standard soon enough.

Change 364232 had a related patch set uploaded (by Mooeypoo; owner: Mooeypoo):
[mediawiki/core@master] RCFilters: Change legend heading for the beta feature

https://gerrit.wikimedia.org/r/364232

The above fix is for the message. I'm still trying to verify where to set up the new default for expansion, that fix will come soon.

Apparently, there is a betalabs regression issue regarding this spec:

Once collapsed (or subsequently opened) the Legend box retains the selected state (as now).

If RC page loads with uncollapsed Legend, it will be displayed uncollapsed on each page reload disregarding users' collapse actions.

Note 1: testwiki (wmf.7) does not have the issue.
Note 2: without New filters enabled, the Legend will be briefly displayed with each page reload.

Change 364232 merged by jenkins-bot:
[mediawiki/core@master] RCFilters: Change legend heading for the beta feature

https://gerrit.wikimedia.org/r/364232

The version on beta is lacking the "Help" link.

Etonkovidova updated the task description. (Show Details)Jul 12 2017, 9:04 PM

@Mooeypoo
Three specs are missing:
(1)

The legend is open by default (as now).

Are the following defined as a default state?

  • A new user logs in first time ever. The Legend is open. A user opts in via the invite popover - the Legend will be displayed collapsed.
  • A user restores all defaults setting. This does not apply to the Legend state. The Legend will be displayed collapsed or uncollapsed according to a user's last choice for the Legend state.

(2)

Once collapsed (or subsequently opened) the Legend box retains the selected state (as now).

As per my comment earlier - if a user un-collapse the Legend, and then collapse it - the state won't be preserved on a page reload.

(3) The following spec is not implemented.

The Help link continues to link to https://en.wikipedia.org/wiki/Help:Watchlist#How_to_read_a_watchlist

Change 368521 had a related patch set uploaded (by Mooeypoo; owner: Mooeypoo):
[mediawiki/core@master] RCFilters: Remember legend expand/collapse state

https://gerrit.wikimedia.org/r/368521

We found the issue with the legend not preserving state; I have a feeling this is also the cause of the other bugs -- @Etonkovidova can you verify and see what, if any, is still not working?

Catrope added a subscriber: Catrope.

@Mooeypoo
Three specs are missing:
(1)

The legend is open by default (as now).

Are the following defined as a default state?

  • A new user logs in first time ever. The Legend is open. A user opts in via the invite popover - the Legend will be displayed collapsed.

I don't understand what you're saying here, but if opting into the beta feature magically changes the default collapsed/expanded state of the legend, that would be bad. I don't see how that would be possible though; could you confirm whether this still happens with Moriel's fix?

  • A user restores all defaults setting. This does not apply to the Legend state. The Legend will be displayed collapsed or uncollapsed according to a user's last choice for the Legend state.

(2)

Once collapsed (or subsequently opened) the Legend box retains the selected state (as now).

As per my comment earlier - if a user un-collapse the Legend, and then collapse it - the state won't be preserved on a page reload.

This will be fixed once Moriel's patch above (which I just approved) merges.

(3) The following spec is not implemented.

The Help link continues to link to https://en.wikipedia.org/wiki/Help:Watchlist#How_to_read_a_watchlist

That seems to imply there was a help link there to begin with, which I don't see. Maybe that help link is an enwiki-specific invention?

Change 368521 merged by jenkins-bot:
[mediawiki/core@master] RCFilters: Remember legend expand/collapse state

https://gerrit.wikimedia.org/r/368521

I'm a little confused by the discussion above and what current state of play is. But I don't see anything to indicate that these three requirements, marked red by elena above, should not stand:

Are we doing all that? (Don't you love it when seemingly small tasks suddenly get big? Sigh.)

I'm a little confused by the discussion above and what current state of play is. But I don't see anything to indicate that these three requirements, marked red by elena above, should not stand:

  • The legend is open by default (as now).

Yes.

  • Once collapsed (or subsequently opened) the Legend box retains the selected state (as now).

Yes.

This link appears to be a customization specific to English Wikipedia, and for some reason this customization (as well as one that changes the text "List of abbreviations" to "Legend") seems to be broken when the beta feature is enabled, maybe because we moved the legend. I only discovered that just now, I'll see if I can find out why this is.

This link appears to be a customization specific to English Wikipedia, and for some reason this customization (as well as one that changes the text "List of abbreviations" to "Legend") seems to be broken when the beta feature is enabled, maybe because we moved the legend. I only discovered that just now, I'll see if I can find out why this is.

The reason it breaks is because we changed the text "Legend" to "List of abbreviations" ourselves as part of the legend task, and we did this only in beta. The help link is implemented by the enwiki people by overriding the "Legend" message, and they did not (yet?) override the "List of abbreviations" message to add it there too. I can do that for them if you like.

If that will fix it, then go for it.

But it will say "List of abbreviations" still (again?), right?

  • Once collapsed (or subsequently opened) the Legend box retains the selected state (as now).

In wmf.11 Recent changes Legend will become uncollapsed with each filters are added/removed. Betalabs does not have the issue.

Re-checked in betalabs and testwiki (wmf.12) - all specs are in place.

QA Recommendation: Resolve

jmatazzoni closed this task as Resolved.Aug 4 2017, 2:05 AM